<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.DataServiceTaskMgtClient" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.ResponseInformation" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.List" %>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>


<link href="css/task.css" rel="stylesheet" type="text/css" media="all"/>
<script type="text/javascript" src="js/taskcommon.js"></script>
<script type="text/javascript" src="js/ui-utils.js"></script>
<fmt:bundle basename="org.wso2.carbon.dataservices.ui.i18n.Resources">
<carbon:breadcrumb label="dataservices.task.header.new"
                   resourceBundle="org.wso2.carbon.dataservices.ui.i18n.Resources"
                   topPage="false" request="<%=request%>"/>

<script type="text/javascript">
    jQuery(document).ready(function() {
        jQuery("#loadClassButton").click(function() {
            jQuery("#modelDescription").load("classload-ajaxprocessor.jsp", {taskClass: jQuery("#taskClass").val(),taskGroup: jQuery("#taskGroup").val()},
                    function(res, status, t) {
                        if (status != "success") {
                            CARBON.showErrorDialog('<fmt:message key="dataservices.task.error.state"/>');
                        }
                    });
            return false;
        });
    });
</script>
<%
    DataServiceTaskMgtClient client;
    Log log = LogFactory.getLog(this.getClass());

    String backendServerUrl = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configurationContext = (ConfigurationContext) config.
            getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    try {
        client = new DataServiceTaskMgtClient(cookie, backendServerUrl,
                configurationContext);
        ResponseInformation responseInfoJobGroups = client.getAllJobGroups();

        if (responseInfoJobGroups.isFault()) {
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog('<%=responseInfoJobGroups.getMessage()%>');
    });
</script>

<% return;
} else {

%>
<form method="post" name="taskcreationform" id="taskcreationform" action="saveTask.jsp">

    <div id="middle">
        <h2><fmt:message key="dataservices.task.header.new"/></h2>

        <div id="workArea">

            <table class="styledLeft noBorders" cellspacing="0" cellpadding="0" border="0">
                <thead>
                <tr>
                    <th colspan="3"><fmt:message key="dataservices.task.basic.information"/></th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td style="width:150px"><fmt:message key="dataservices.task.name"/><span
                            class="required">*</span></td>
                    <td align="left">
                        <input id="taskName" name="taskName" class="longInput" type="text"/>
                    </td>
                </tr>
                <tr>
                    <td style="width:150px"><fmt:message key="dataservices.task.group"/><span
                            class="required">*</span></td>
                    <td align="left">
                        <select id="taskGroup" name="taskGroup" class="longInput">
                            <%
                                Object result = responseInfoJobGroups.getResult();
                                if (result instanceof String[]) {
                                    String[] groups = (String[]) result;
                                    for (String group : groups) { %>
                            <option value="<%=group%>">
                                <%=group%>
                            </option>
                            <% }
                            }%>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td><fmt:message key="dataservices.task.implementation"/><span class="required">*</span>
                    </td>
                    <td align="left">
                        <input id="taskClass" name="taskClass" class="longInput" type="text"
                               value="org.wso2.carbon.dataservices.taskscheduler.SchedulingTask"/>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" class="middle-header"><fmt:message
                            key="dataservices.task.trigger.text"/></td>
                </tr>
                <input type="hidden" name="taskTrigger" id="taskTrigger" value="simple"/>

                <tr id="triggerCountTR">
                    <td><fmt:message key="dataservices.task.trigger.count"/></td>
                    <td>
                        <input id="triggerCount" name="triggerCount" class="longInput"
                               type="text" value=""/>
                    </td>
                </tr>
                <tr id="triggerIntervalTR">
                    <td><fmt:message key="dataservices.task.trigger.interval"/><span
                            class="required">*</span></td>
                    <td>
                        <input id="triggerInterval" name="triggerInterval" class="longInput"
                               type="text"
                               value=""/>
                    </td>
                </tr>
                <tr id="startTimeTR">
                    <td><fmt:message key="dataservices.task.trigger.start.time"/><span
                            class="required">*</span></td>
                    <td>
                        <input id="startTime" name="startTime" class="longInput"
                               type="text"
                               value=""/>
                    </td>
                </tr>
                <tr id="triggerCronTR" style="display:none;">
                    <td><fmt:message key="dataservices.task.trigger.type.cron"/><span
                            class="required">*</span></td>
                    <td>
                        <input id="triggerCron" name="triggerCron" type="text" class="longInput"
                               value=""/>
                    </td>
                </tr>

                <tr>
                    <td colspan="2" class="middle-header"><fmt:message
                            key="dataservices.task.miscellaneous.information"/></td>
                </tr>
                <tr>
                    <td style="width:150px"><fmt:message key="dataservices.service.name"/><span
                            class="required">*</span></td>
                    <td align="left">
                        <select id="serviceList" name="serviceList" class="longInput"
                                onchange="getOperations(this);">
                            <option value="select">------------------------SELECT----------------------------</option>
                            <%
                                ResponseInformation serviceListResponse = client.getServicesList();
                                String[] services = (String[]) serviceListResponse.getResult();
                                if (services != null) {
                                    for (String service : services) { %>
                            <option value="<%=service%>">
                                <%=service%>
                            </option>
                            <% }
                            }%>
                        </select>
                    </td>
                    <input id="dataServiceName" name="dataServiceName" value="" type="hidden"/>
                </tr>
                <tr>
                    <td style="width:150px"><fmt:message key="dataservices.operation.list"/><span
                            class="required">*</span></td>

                    <td align="left">
                        <select id="operationList" name="operationList" class="longInput" onchange="setOperationName()">
                        </select>
                    </td>
                </tr>
                <input id="operationName" name="operationName" value="" type="hidden"/>

                <tr>
                    <td class="buttonRow" colspan="3">
                        <input class="button" type="button"
                               value="<fmt:message key="dataservices.task.button.schedule.text"/>"
                               onclick="tasksave('<fmt:message key="dataservices.task.name.cannotfound.msg"/>','<fmt:message key="dataservices.task.classname.cannotfound.msg"/>','<fmt:message key="dataservices.task.cron.cannotfound.msg"/>','<fmt:message key="dataservices.task.count.cannotfound.msg"/>','<fmt:message key="dataservices.task.interval.cannotfound.msg"/>',document.taskcreationform); return false;"/>
                        <input class="button" type="button"
                               value="<fmt:message key="dataservices.task.cancel.button.text"/>"
                               onclick="document.location.href='tasks.jsp?ordinal=0';"/>
                    </td>
                </tr>
                </tbody>
            </table>
            <%--<script type="text/javascript">--%>
                <%--autoredioselect();--%>
            <%--</script>--%>
        </div>
        <div id="tdiv"></div>
    </div>

</form>
<%
    }
} catch (Throwable e) {
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog('<%=e.getMessage()%>');
    });
</script>
<%
        return;
    }
%>
</fmt:bundle>

