<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.synapse.task.TaskDescription" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.DataServiceTaskConstants" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.DataServiceTaskMgtClient" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.DataServiceTaskMgtHelper" %>
<%@ page import="org.wso2.carbon.dataservices.ui.taskscheduler.ResponseInformation" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.Map" %>

<link type="text/css" rel="stylesheet" href="../admin/css/global.css"/>
<!--script type="text/javascript" src="global-params.js"></script-->
<script type="text/javascript" src="js/taskcommon.js"></script>

<%
    try {
        String saveMode = request.getParameter("saveMode");
        String taskName = request.getParameter("taskName");
        String taskGroup = request.getParameter("taskGroup");
        boolean edit = "edit".equals(saveMode);
        DataServiceTaskMgtClient client;
        ResponseInformation responseInformation = null;
        Map<String, Object> jobDataMap;

        String backendServerUrl = CarbonUIUtil.getServerURL(config.getServletContext(),session);
        ConfigurationContext configurationContext = (ConfigurationContext) config.
                getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie= (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

        client = new DataServiceTaskMgtClient(cookie,backendServerUrl,configurationContext);

        if ("edit".equals(saveMode)) {
             TaskDescription taskDescription = DataServiceTaskMgtHelper.createTaskDescription(request);
            jobDataMap = DataServiceTaskMgtHelper.createJobDataMap(request);
            jobDataMap.put(DataServiceTaskConstants.BACK_END_URL, backendServerUrl);

            ConfigurationContext configCtx = ((ConfigurationContext) config.getServletContext().getAttribute(
                CarbonConstants.CONFIGURATION_CONTEXT));
            configCtx.setProperty(DataServiceTaskConstants.JOB_DATA_MAP, jobDataMap);
            config.getServletContext().setAttribute(CarbonConstants.CONFIGURATION_CONTEXT, configCtx);
            responseInformation = client.editTaskDescription(taskDescription);
        } else if("delete".equals(saveMode)) {
            client.deleteTaskDescription(taskName, taskGroup);
        } else {
             TaskDescription taskDescription = DataServiceTaskMgtHelper.createTaskDescription(request);
                jobDataMap = DataServiceTaskMgtHelper.createJobDataMap(request);
            jobDataMap.put(DataServiceTaskConstants.BACK_END_URL, backendServerUrl);

            ConfigurationContext configCtx = ((ConfigurationContext) config.getServletContext().getAttribute(
                CarbonConstants.CONFIGURATION_CONTEXT));
            configCtx.setProperty(DataServiceTaskConstants.JOB_DATA_MAP, jobDataMap);
            config.getServletContext().setAttribute(CarbonConstants.CONFIGURATION_CONTEXT, configCtx);
            responseInformation = client.addTaskDescription(taskDescription,
                    (String)jobDataMap.get(DataServiceTaskConstants.DATA_SERVICE_NAME),
                    (String)jobDataMap.get(DataServiceTaskConstants.OPERATION_NAME),
                    (String)jobDataMap.get(DataServiceTaskConstants.BACK_END_URL));
        }
        if (responseInformation != null && responseInformation.isFault()) {
%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog('<%=responseInformation.getMessage()%>', function () {
            goBackOnePage();
        }, function () {
            goBackOnePage();
        });
    });
</script>
<% } else {
%>
<script type="text/javascript">
    forward("tasks.jsp");
</script>
<% }
} catch (Exception e) {%>
<script type="text/javascript">
    jQuery(document).ready(function() {
        CARBON.showErrorDialog('<%=e.getMessage()%>', function () {
            goBackOnePage();
        }, function () {
            goBackOnePage();
        });
    });
</script>
<%}%>
